﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Windows.Forms;
using System.Windows.Forms.Integration;
using Infragistics.Controls.Grids;
using Infragistics.Olap;
using Infragistics.Olap.Data;
using Infragistics.Olap.FlatData;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public static int LevelDepth;
        XamPivotGrid xamPivotGrid1;
        FlatDataSource dataSource;
        public Form1()
        {
            InitializeComponent();

            ElementHost eh = new ElementHost();
            eh.Dock = DockStyle.Fill;

            xamPivotGrid1 = new XamPivotGrid();
            eh.Child = xamPivotGrid1;

            this.Controls.Add(eh);

            Data = new ObservableCollection<Data>();
            Random r = new Random();

            for (int i = 0; i < 50; i++)
            {


                int days = i % 5;
                Data.Add(new Data
                {
                    Test = "Test" + r.Next(10),
                    Result = r.Next(5000),
                    Date = DateTime.Now.AddDays(days + 10)
                });
            }

        }

        public ObservableCollection<Data> Data { get; set; }
        

        void DataSource_ResultChanged(object sender, System.ComponentModel.AsyncCompletedEventArgs e)
        {
            DataSourceBase dataSourceBase = (DataSourceBase)sender;
            dataSourceBase.ResultChanged -= this.DataSource_ResultChanged;

            dataSourceBase.HierarchyExpansionMode = HierarchyExpansionMode.DrillDown;
            dataSourceBase.UpdateVisualMembers(Infragistics.Olap.ExecutionContext.Rows);
            dataSourceBase.UpdateVisualMembers(Infragistics.Olap.ExecutionContext.Columns);
            dataSourceBase.HierarchyExpansionMode = HierarchyExpansionMode.SingleLevelOnly;

            dataSourceBase.RefreshGrid();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            string mStr = "Result";

            dataSource = new FlatDataSource()
            {
                ItemsSource = Data,
                Cube = DataSourceBase.GenerateInitialCube("Test Results"),
                Rows = DataSourceBase.GenerateInitialItems("[Test].[Test]"),
                Columns = DataSourceBase.GenerateInitialItems("[Date].[Date]"),
                Measures = DataSourceBase.GenerateInitialItems(mStr)

            };

            xamPivotGrid1.DataSource = dataSource;
        }

    }

    public class Data : INotifyPropertyChanged
    {

        public string Test
        {
            get { return test; }
            set
            {
                test = value;
                OnPropertyChanged("Test");
            }
        }

        public int Result
        {
            get { return result; }
            set
            {
                result = value;
                OnPropertyChanged("Result");
            }
        }

        public DateTime Date
        {
            get { return date; }
            set
            {
                date = value;
                OnPropertyChanged("Date");
            }
        }


        public event PropertyChangedEventHandler PropertyChanged;
        private string test;
        private int result;
        private DateTime date;

        public void OnPropertyChanged(string name)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(name));
            }
        }
    }

}